/*******************************************************
This program was created by the
CodeWizardAVR V3.12 Advanced
Automatic Program Generator
 Copyright 1998-2014 Pavel Haiduc, HP InfoTech s.r.l.
http://www.hpinfotech.com

Date    : 21/08/2017
Author  : Mohammad amin Hardani

Chip type               : ATmega32A
Program type            : Application
AVR Core Clock frequency: 1.000000 MHz
Memory model            : Small
External RAM size       : 0
Data Stack size         : 512
*******************************************************/

#include <mega32a.h>
#include <alcd.h>
#include <ff.h>
#include <delay.h>

unsigned char buffer[16];
FRESULT res;
unsigned int nbytes;
FATFS drive;
FIL file;
char path[]= "0:/url.txt";
char text[] = "http://chipkadeh.ir";

// Timer 0 overflow interrupt service routine
// disk_teimerproc avoids MemoryCard sleep!
interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
    TCNT0=0x31;
    disk_timerproc();
}

void main(void)
{
    lcd_init(16);
    
    // Timer/Counter 0 initialization
    // Clock source: System Clock
    // Clock value: 3.906 kHz
    // Mode: Normal top=0xFF
    // OC0 output: Disconnected
    // Timer Period: 52.992 ms
    TCCR0=(0<<WGM00) | (0<<COM01) | (0<<COM00) | (0<<WGM01) | (1<<CS02) | (0<<CS01) | (0<<CS00);
    TCNT0=0x31;
    OCR0=0x00;
    // Timer(s)/Counter(s) Interrupt(s) initialization
    TIMSK=(0<<OCIE2) | (0<<TOIE2) | (0<<TICIE1) | (0<<OCIE1A) | (0<<OCIE1B) | (0<<TOIE1) | (0<<OCIE0) | (1<<TOIE0);
    
    #asm("sei")
    
    DDRB.1 = 1;
    PORTB.1 = 0;
    
/* ============================ Write to disk ============================*/    
    f_mount(0,&drive);  // mount
    f_open(&file, "url.txt", FA_WRITE|FA_OPEN_ALWAYS|FA_OPEN_EXISTING);
    f_write(&file,text,sizeof(text)-1,&nbytes);     // sizeof()-1 means no "\r" or "\n" character 
    f_close(&file);
    f_mount(0, 0);  // dismount
    
/* ============================ Read from disk ===========================*/    
    if ((res=f_mount(0,&drive))==FR_OK)
        lcd_putsf("FAT mounted = OK");
    delay_ms(1000);
    
    lcd_clear();
    if ((res=f_open(&file,path,FA_READ))==FR_OK)
        lcd_putsf("File open: url.txt");
    delay_ms(1000);
    
    lcd_clear();    
    if ((res=f_read(&file,buffer,20,&nbytes))==FR_OK)
        lcd_putsf("Reading Data");   
    delay_ms(1000);
    lcd_clear();
    lcd_puts(buffer);
    delay_ms(1000);
        
    f_close(&file);
    while (1);
}
